/*
 * Coordinator.hpp
 *
 *  Created on: 03.09.2013
 *      Author: heber
 */

#ifndef COORDINATOR_HPP_
#define COORDINATOR_HPP_

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "FunctionApproximation/FunctionModel.hpp"

#include <boost/shared_ptr.hpp>

/** This class is the interface for all functors converting
 * a list of distances (arguments_t) into internal coordinates.
 *
 */
struct Coordinator
{
  typedef boost::shared_ptr<Coordinator> ptr;

  virtual double operator()(const FunctionModel::arguments_t &arguments) const=0;
};

#endif /* COORDINATOR_HPP_ */
